SynchStatsEvent = {};
SynchStatsEvent_mt = Class(SynchStatsEvent, Event);
InitEventClass(SynchStatsEvent, "SynchStatsEvent");
function SynchStatsEvent:emptyNew()
    local self = Event:new(SynchStatsEvent_mt);
    self.className="SynchStatsEvent";
    return self;
end;

function SynchStatsEvent:new()
    local self = SynchStatsEvent:emptyNew(); 
    return self;
end;

function SynchStatsEvent:writeStream(streamId, connection)
	local stats = g_currentMission.treeManager.stats;

	streamWriteInt16(streamId, stats.plantedTreesTotal);
	streamWriteInt16(streamId, stats.plantedTreesCurrent);
	streamWriteInt16(streamId, stats.cutTreesTotal);
	streamWriteInt16(streamId, stats.cutTreesCurrent);
	streamWriteInt32(streamId, math.floor(stats.woodChipsTotal));
	streamWriteInt32(streamId, math.floor(stats.woodChipsCurrent));
	streamWriteInt32(streamId, math.floor(stats.earnedMoneyTotal));
	streamWriteInt32(streamId, math.floor(stats.earnedMoneyCurrent));
	streamWriteInt16(streamId, stats.chippedTreesTotal);
	streamWriteInt16(streamId, stats.chippedTreesCurrent);
	streamWriteInt16(streamId, stats.soldTreesTotal);
	streamWriteInt16(streamId, stats.soldTreesCurrent);
end;

function SynchStatsEvent:readStream(streamId, connection)
	local stats = g_currentMission.treeManager.stats;
	
	stats.plantedTreesTotal = streamReadInt16(streamId);
	stats.plantedTreesCurrent = streamReadInt16(streamId);
	stats.cutTreesTotal = streamReadInt16(streamId);
	stats.cutTreesCurrent = streamReadInt16(streamId);
	stats.woodChipsTotal = streamReadInt32(streamId);
	stats.woodChipsCurrent = streamReadInt32(streamId);
	stats.earnedMoneyTotal = streamReadInt32(streamId);
	stats.earnedMoneyCurrent = streamReadInt32(streamId);
	stats.chippedTreesTotal = streamReadInt16(streamId);
	stats.chippedTreesCurrent = streamReadInt16(streamId);
	stats.soldTreesTotal = streamReadInt16(streamId);
	stats.soldTreesCurrent = streamReadInt16(streamId);
end;